--
-- SQL script for creating tables for KS application
--     using SQL standard, some RDBMS needs tweaking:
--
--        Microsoft SQL Server:
--            replace TIMESTAMP  with DATETIME
--
--        PostreSQL:
--            works as is
--
--        Oracle:
--            replace NUMERIC    with NUMBER
--            replace TIMESTAMP  with DATE
--            replace TIME       with DATE
--            replace VARCHAR    with VARCHAR2
--            replace INTEGER    with NUMBER(10)
--            replace SMALLINT   with NUMBER(5)
--
--        Firebird:
--            works as is
--
--        Sybase Adaptive Server Enterprise:
--            replace TIMESTAMP  with DATETIME


CREATE TABLE dr_in
(
  cisprik     NUMERIC(10, 0) NOT NULL,
  status      CHAR(1),
  kodslu      NUMERIC(10, 0) NOT NULL,
  priorita    CHAR(1)        NOT NULL,
  cavy        TIMESTAMP,
  crc         INTEGER,
  data        VARCHAR(2048),
  CONSTRAINT pk_dr_in PRIMARY KEY(cisprik)
);

CREATE TABLE dr_out
(
  cisprik     NUMERIC(10, 0) NOT NULL,
  status      CHAR(1),
  cazpra      TIMESTAMP      NOT NULL,
  nako        CHAR(7)        NOT NULL,
  pocet       INTEGER,
  datbur      DATE,
  casbur      TIMESTAMP,
  CONSTRAINT pk_dr_out PRIMARY KEY(cisprik),
  CONSTRAINT fk_dr_out__dr_in FOREIGN KEY(cisprik) REFERENCES dr_in(cisprik)
);

CREATE TABLE status_in
(
  cisprik     NUMERIC(10, 0)
);

INSERT INTO status_in VALUES(0);

CREATE TABLE stav_ks
(
  sluzba      CHAR(2)        NOT NULL,
  cazpra      TIMESTAMP      NOT NULL,
  stav        CHAR(1)        NOT NULL,
  rozhr      VARCHAR(10)    NOT NULL,
  CONSTRAINT pk_stav_ks PRIMARY KEY(sluzba, rozhr)
);

CREATE TABLE dr_dt
(
  cisprik     NUMERIC(10, 0) NOT NULL,
  status      CHAR(1),
  kodslu      NUMERIC(10, 0) NOT NULL,
  porcis      NUMERIC(10, 0) NOT NULL,
  cazpra      TIMESTAMP      NOT NULL,
  cavzds      TIMESTAMP,
  crc         INTEGER,
  data        VARCHAR(5000)   NOT NULL,
  CONSTRAINT pk_dr_dt PRIMARY KEY(cisprik)
);

CREATE TABLE dr_dt_pse
(
  cisprik     NUMERIC(10, 0) NOT NULL,
  status      CHAR(1),
  kodslu      NUMERIC(10, 0) NOT NULL,
  porcis      NUMERIC(10, 0) NOT NULL,
  cazpra      TIMESTAMP      NOT NULL,
  cavzds      TIMESTAMP,
  crc         INTEGER,
  data        VARCHAR(5000)   NOT NULL,
  CONSTRAINT pk_dr_dt_pse PRIMARY KEY(cisprik)
);

CREATE TABLE dr_pt
(
  cisprik     NUMERIC(10, 0) NOT NULL,
  status      CHAR(1),
  kodfir      CHAR(3),
  kodslu      NUMERIC(10, 0) NOT NULL,
  porcis      NUMERIC(10, 0) NOT NULL,
  cazpra      TIMESTAMP      NOT NULL,
  cavzds      TIMESTAMP,
  crc         INTEGER,
  data        VARCHAR(5000)   NOT NULL,
  CONSTRAINT pk_dr_pt PRIMARY KEY(cisprik)
);

CREATE TABLE dr_pt_pse
(
  cisprik     NUMERIC(10, 0) NOT NULL,
  status      CHAR(1),
  kodfir      CHAR(3),
  kodslu      NUMERIC(10, 0) NOT NULL,
  porcis      NUMERIC(10, 0) NOT NULL,
  cazpra      TIMESTAMP      NOT NULL,
  cavzds      TIMESTAMP,
  crc         INTEGER,
  data        VARCHAR(5000)   NOT NULL,
  CONSTRAINT pk_dr_pt_pse PRIMARY KEY(cisprik)
);

CREATE TABLE dr_it
(
  cisprik     NUMERIC(10, 0) NOT NULL,
  status      CHAR(1),
  kodslu      NUMERIC(10, 0) NOT NULL,
  porcis      NUMERIC(10, 0) NOT NULL,
  cazpra      TIMESTAMP      NOT NULL,
  data        VARCHAR(5000)  NOT NULL,
  CONSTRAINT pk_dr_it PRIMARY KEY (cisprik, porcis)
);
